#ifndef ENG28J60
#define ENC28J60

#define MIN(a,b)	((a<b)?(a):(b))
#define MAX(a,b)	((a>b)?(a):(b))

#define ENC28J60_CS  *((volatile unsigned long *)(BITBAND_PERI(GPIOA_ODR,4)))

/*----------SPI Befehlscodes fr ENC28J60----------*/
#define READ_CTRL_REG		0x00
#define READ_BUFF_MEM		0x3a
#define WRITE_CTRL_REG		0x40
#define WRITE_BUFF_MEM		0x7a
#define BIT_FIELD_SET		0x80
#define BIT_FIELD_CLR		0xa0
#define SYSTEM_RESET_CMD	0xff

/*----------Maskierungen fr "Adressen"----------*/
#define BANK0 0x00
#define BANK1 0x40
#define BANK2 0x80
#define BANK3 0xc0

#define BANK_MASK 0xc0	//Bank aus "Adresse" heraus maskieren
#define ADDR_MASK 0x1f	//Echte Adresse aus "Adresse" heraus maskieren
#define USE_DUMMY 0x20	//Dummy aus "Adresse" heraus maskieren (bei MAC/MII-Register)



/*----------Generelle Register----------*/
#define EIE              0x1B
#define EIR              0x1C
#define ESTAT            0x1D
#define ECON2            0x1E
#define ECON1            0x1F

/*----------Registerbank 0----------*/
#define ERDPTL           (0x00|BANK0)
#define ERDPTH           (0x01|BANK0)
#define EWRPTL           (0x02|BANK0)
#define EWRPTH           (0x03|BANK0)
#define ETXSTL           (0x04|BANK0)
#define ETXSTH           (0x05|BANK0)
#define ETXNDL           (0x06|BANK0)
#define ETXNDH           (0x07|BANK0)
#define ERXSTL           (0x08|BANK0)
#define ERXSTH           (0x09|BANK0)
#define ERXNDL           (0x0A|BANK0)
#define ERXNDH           (0x0B|BANK0)
#define ERXRDPTL         (0x0C|BANK0)
#define ERXRDPTH         (0x0D|BANK0)
#define ERXWRPTL         (0x0E|BANK0)
#define ERXWRPTH         (0x0F|BANK0)
#define EDMASTL          (0x10|BANK0)
#define EDMASTH          (0x11|BANK0)
#define EDMANDL          (0x12|BANK0)
#define EDMANDH          (0x13|BANK0)
#define EDMADSTL         (0x14|BANK0)
#define EDMADSTH         (0x15|BANK0)
#define EDMACSL          (0x16|BANK0)
#define EDMACSH          (0x17|BANK0)
//--					 (0x18|BANK0)	
//--					 (0x19|BANK0)

/*----------Registerbank 1----------*/
#define EHT0             (0x00|BANK1)
#define EHT1             (0x01|BANK1)
#define EHT2             (0x02|BANK1)
#define EHT3             (0x03|BANK1)
#define EHT4             (0x04|BANK1)
#define EHT5             (0x05|BANK1)
#define EHT6             (0x06|BANK1)
#define EHT7             (0x07|BANK1)
#define EPMM0            (0x08|BANK1)
#define EPMM1            (0x09|BANK1)
#define EPMM2            (0x0A|BANK1)
#define EPMM3            (0x0B|BANK1)
#define EPMM4            (0x0C|BANK1)
#define EPMM5            (0x0D|BANK1)
#define EPMM6            (0x0E|BANK1)
#define EPMM7            (0x0F|BANK1)
#define EPMCSL           (0x10|BANK1)
#define EPMCSH           (0x11|BANK1)
//--					 (0x12|BANK1)
//--					 (0x13|BANK1)
#define EPMOL            (0x14|BANK1)
#define EPMOH            (0x15|BANK1)
//Reserved	             (0x16|BANK1)
//Reserved	             (0x17|BANK1)
#define ERXFCON          (0x18|BANK1)
#define EPKTCNT          (0x19|BANK1)

/*----------Registerbank 2----------*/
#define MACON1           (0x00|BANK2|USE_DUMMY)
//Reserved		         (0x01|BANK2|USE_DUMMY)
#define MACON3           (0x02|BANK2|USE_DUMMY)
#define MACON4           (0x03|BANK2|USE_DUMMY)
#define MABBIPG          (0x04|BANK2|USE_DUMMY)
//--			         (0x05|BANK2|USE_DUMMY)
#define MAIPGL           (0x06|BANK2|USE_DUMMY)
#define MAIPGH           (0x07|BANK2|USE_DUMMY)
#define MACLCON1         (0x08|BANK2|USE_DUMMY)
#define MACLCON2         (0x09|BANK2|USE_DUMMY)
#define MAMXFLL          (0x0A|BANK2|USE_DUMMY)
#define MAMXFLH          (0x0B|BANK2|USE_DUMMY)
//Reserved		         (0x0C|BANK2|USE_DUMMY)
//Reserved		         (0x0D|BANK2|USE_DUMMY)
//Reserved		         (0x0E|BANK2|USE_DUMMY)
//--			         (0x0F|BANK2|USE_DUMMY)
//Reserved		         (0x10|BANK2|USE_DUMMY)
//Reserved		         (0x11|BANK2|USE_DUMMY)
#define MICMD            (0x12|BANK2|USE_DUMMY)
//--			         (0x13|BANK2|USE_DUMMY)
#define MIREGADR         (0x14|BANK2|USE_DUMMY)
//Reserved		         (0x15|BANK2|USE_DUMMY)
#define MIWRL            (0x16|BANK2|USE_DUMMY)
#define MIWRH            (0x17|BANK2|USE_DUMMY)
#define MIRDL            (0x18|BANK2|USE_DUMMY)
#define MIRDH            (0x19|BANK2|USE_DUMMY)

/*----------Registerbank 3----------*/
#define MAADR5           (0x00|BANK3|USE_DUMMY)
#define MAADR6           (0x01|BANK3|USE_DUMMY)
#define MAADR3           (0x02|BANK3|USE_DUMMY)
#define MAADR4           (0x03|BANK3|USE_DUMMY)
#define MAADR1           (0x04|BANK3|USE_DUMMY)
#define MAADR2           (0x05|BANK3|USE_DUMMY)
#define EBSTSD           (0x06|BANK3|USE_DUMMY)
#define EBSTCON          (0x07|BANK3|USE_DUMMY)
#define EBSTCSL          (0x08|BANK3|USE_DUMMY)
#define EBSTCSH          (0x09|BANK3|USE_DUMMY)
#define MISTAT           (0x0A|BANK3|USE_DUMMY)
//--					 (0x0B|BANK3|USE_DUMMY)
//--					 (0x0C|BANK3|USE_DUMMY)
//--					 (0x0D|BANK3|USE_DUMMY)
//--					 (0x0E|BANK3|USE_DUMMY)
//--					 (0x0F|BANK3|USE_DUMMY)
//--					 (0x10|BANK3|USE_DUMMY)
//--					 (0x11|BANK3|USE_DUMMY)
#define EREVID           (0x12|BANK3|USE_DUMMY)
//--					 (0x13|BANK3|USE_DUMMY)
//--					 (0x14|BANK3|USE_DUMMY)
#define ECOCON           (0x15|BANK3|USE_DUMMY)
//Reserved				 (0x16|BANK3|USE_DUMMY)
#define EFLOCON          (0x17|BANK3|USE_DUMMY)
#define EPAUSL           (0x18|BANK3|USE_DUMMY)
#define EPAUSH           (0x19|BANK3|USE_DUMMY)

/*----------PHY-Register----------*/
#define PHCON1           0x00
#define PHSTAT1          0x01
#define PHID1            0x02
#define PHID2            0x03
#define PHCON2           0x10
#define PHSTAT2          0x11
#define PHIE             0x12
#define PHIR             0x13
#define PHLCON           0x14



//ECON1-Register Bitdefinitionen
#define ECON1_TXRST      0x80
#define ECON1_RXRST      0x40
#define ECON1_DMAST      0x20
#define ECON1_CSUMEN     0x10
#define ECON1_TXRTS      0x08
#define ECON1_RXEN       0x04
#define ECON1_BSEL1      0x02
#define ECON1_BSEL0      0x01

//ECON2-Register Bitdefinitionen
#define ECON2_AUTOINC    0x80
#define ECON2_PKTDEC     0x40
#define ECON2_PWRSV      0x20
#define ECON2_VRPS       0x08

//ESTAT-Register Bitdefinitionen
#define ESTAT_INT        0x80
#define ESTAT_BUFER      0x40
#define ESTAT_LATECOL    0x10
#define ESTAT_RXBUSY     0x04
#define ESTAT_TXABRT     0x02
#define ESTAT_CLKRDY     0x01

//MISTAT-Register Bitdefinitionen
#define MISTAT_NVALID    0x08
#define MISTAT_SCAN      0x02
#define MISTAT_BUSY      0x01

//EIE-Register Bitdefinitionen
#define EIE_INTIE        0x80
#define EIE_PKTIE        0x40
#define EIE_DMAIE        0x20
#define EIE_LINKIE       0x10
#define EIE_TXIE         0x08
#define EIE_WOLIE        0x04
#define EIE_TXERIE       0x02
#define EIE_RXERIE       0x01

//EIR-Register Bitdefinitionen
#define EIR_PKTIF        0x40
#define EIR_DMAIF        0x20
#define EIR_LINKIF       0x10
#define EIR_TXIF         0x08
#define EIR_WOLIF        0x04
#define EIR_TXERIF       0x02
#define EIR_RXERIF       0x01

//ERXFCON-Register Bitdefinitionen
#define ERXFCON_UCEN     0x80
#define ERXFCON_ANDOR    0x40
#define ERXFCON_CRCEN    0x20
#define ERXFCON_PMEN     0x10
#define ERXFCON_MPEN     0x08
#define ERXFCON_HTEN     0x04
#define ERXFCON_MCEN     0x02
#define ERXFCON_BCEN     0x01

//MACON1-Register Bitdefinitionen
#define MACON1_LOOPBK    0x10
#define MACON1_TXPAUS    0x08
#define MACON1_RXPAUS    0x04
#define MACON1_PASSALL   0x02
#define MACON1_MARXEN    0x01

//MACON2-Register Bitdefinitionen
#define MACON2_MARST     0x80
#define MACON2_RNDRST    0x40
#define MACON2_MARXRST   0x08
#define MACON2_RFUNRST   0x04
#define MACON2_MATXRST   0x02
#define MACON2_TFUNRST   0x01

//MACON3-Register Bitdefinitionen
#define MACON3_PADCFG2   0x80
#define MACON3_PADCFG1   0x40
#define MACON3_PADCFG0   0x20
#define MACON3_TXCRCEN   0x10
#define MACON3_PHDRLEN   0x08
#define MACON3_HFRMLEN   0x04
#define MACON3_FRMLNEN   0x02
#define MACON3_FULDPX    0x01

//MACON4-Register Bitdefinitionen
#define MACON4_DEFER	 0x40
#define MACON4_BPEN		 0x20
#define MACON4_NOBKOFF   0x10

//MICMD-Register Bitdefinitionen
#define MICMD_MIISCAN    0x02
#define MICMD_MIIRD      0x01

//PHY PHCON1-Register Bitdefinitionen
#define PHCON1_PRST      0x8000
#define PHCON1_PLOOPBK   0x4000
#define PHCON1_PPWRSV    0x0800
#define PHCON1_PDPXMD    0x0100

//PHY PHSTAT1-Register Bitdefinitionen
#define PHSTAT1_PFDPX    0x1000
#define PHSTAT1_PHDPX    0x0800
#define PHSTAT1_LLSTAT   0x0004
#define PHSTAT1_JBSTAT   0x0002

//PHY PHCON2-Register Bitdefinitionen
#define PHCON2_FRCLINK   0x4000
#define PHCON2_TXDIS     0x2000
#define PHCON2_JABBER    0x0400
#define PHCON2_HDLDIS    0x0100

//Packet Control Byte Bitdefinitionen
#define PKTCTRL_PHUGEEN  0x08
#define PKTCTRL_PPADEN   0x04
#define PKTCTRL_PCRCEN   0x02
#define PKTCTRL_POVERRIDE 0x01



// start with recbuf at 0/ 
#define RXSTART_INIT     0x0600	
// receive buffer end
#define RXSTOP_INIT      0x1FFF	
// start TX buffer at 0x1FFF-0x0600, pace for one full ethernet frame (~1500 bytes)
#define TXSTART_INIT     0x0000	
// stp TX buffer at end of mem
#define TXSTOP_INIT      0x05FF	 
//
// max frame length which the conroller will accept:
#define        MAX_FRAMELEN        1518        // (note: maximum ethernet frame length would be 1518)

//Ethernet Constants
#define ETHERNET_MIN_PACKET_LENGTH	0x3C
#define ETHERNET_HEADER_LENGTH	0x0E


/*--------------------Initialisierung des ENC28J60--------------------*/
void enc28j60Init(void);

/*--------------------Inhalt eines PHY-Registers verndern--------------------*/
void enc28j60WritePhyReg(unsigned char address, unsigned short daten);

/*--------------------Inhalt eines PHY-Registers auslesen--------------------*/
void enc28j60ReadPhyReg(unsigned char address, unsigned char *testdata1, unsigned char *testdata2);

/*--------------------MAC-Adresse des ENC28J60 lesen--------------------*/
void enc28j60GetMacAddr(unsigned char *macaddr);

/*--------------------Verndern der MAC-Adresse des ENC28J60--------------------*/
void enc28j60SetMacAddr(unsigned char *macaddr);

/*--------------------System Reset des ENC28J60--------------------*/
void enc28j60SysReset(void);

/*--------------------Inhalt eines Registers lesen--------------------*/
void enc28j60Read(unsigned char address, unsigned char* daten);

/*--------------------In ein Register schreiben--------------------*/
void enc28j60Write(unsigned char address, unsigned char daten);

/*--------------------Inhalt eines Registers lesen--------------------*/
//!!!Registerbank muss schon ausgewhlt sein!!!
void enc28j60ReadCTRLreg(unsigned char address, unsigned char* daten);

/*--------------------In ein Register schreiben--------------------*/
//!!!Registerbank muss schon ausgewhlt sein!!!
void enc28j60WriteCTRLreg(unsigned char address, unsigned char daten);

/*--------------------Eine Registerbank auswhlen--------------------*/
void enc28j60SelBank(unsigned char address);

//Read Buffer
void enc28j60ReadBufferMem(unsigned short len, unsigned char* daten);

//Write Buffer
void enc28j60WriteBufferMem(unsigned short len, unsigned char* daten);

void enc28j60BitClr(unsigned char address, unsigned char daten);
void enc28j60BitSel(unsigned char address, unsigned char daten);

void enc28j60PacketSend(unsigned int len, unsigned char* packet);

unsigned int enc28j60PacketReceive(unsigned int maxlen, unsigned char* packet);

#endif
